/*
 *     Botendo
 *     Copyright (C) 2023  limited_dev
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

package de.limited_dev.botendo

import de.limited_dev.botendo.util.Logger
import de.limited_dev.botendo.util.TokenManager
import dev.kord.core.Kord
import dev.kord.gateway.Intent
import dev.kord.gateway.PrivilegedIntent

object Bot {
    //The kord object gets set at app launch
    var kord: Kord? = null
    suspend fun start() {
        //Load config
        TokenManager.load()


        //Don't run the bot when there is no bot token in config
        if (TokenManager.token == "empty") {
            Logger.out("The config does not contain a bot token")
            return
        }

        // start the bot
        kord = Kord(TokenManager.token)
        kord!!.login {
            // Load gateway privileges
            @OptIn(PrivilegedIntent::class)
            intents += Intent.GuildMembers

            @OptIn(PrivilegedIntent::class)
            intents += Intent.MessageContent
        }
    }
}
